import _extends from "@babel/runtime/helpers/esm/extends";
import { line } from 'd3-shape';
import React from 'react';
import { translate } from '../utils/Utils';
import useChartContext from '../utils/chartContext'; //

import { monotoneX } from '../utils/curveMonotone';
var pathDefaultStyle = {
  strokeWidth: 2
};
export default function Line(_ref) {
  var _secondaryAxis$curve;

  var primaryAxis = _ref.primaryAxis,
      secondaryAxis = _ref.secondaryAxis,
      allSeries = _ref.series;

  var _useChartContext = useChartContext(),
      getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
      getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
      useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
      gridDimensions = _useChartContext.gridDimensions;

  var curve = (_secondaryAxis$curve = secondaryAxis.curve) != null ? _secondaryAxis$curve : monotoneX;

  var _useFocusedDatumAtom = useFocusedDatumAtom(),
      focusedDatum = _useFocusedDatumAtom[0];

  var xAxis = primaryAxis.isVertical ? secondaryAxis : primaryAxis;
  var yAxis = !primaryAxis.isVertical ? secondaryAxis : primaryAxis;

  var getX = function getX(datum) {
    var _datum$stackData;

    return xAxis.scale(xAxis.stacked ? (_datum$stackData = datum.stackData) == null ? void 0 : _datum$stackData[1] : xAxis.getValue(datum.originalDatum));
  };

  var getY = function getY(datum) {
    var _datum$stackData2;

    return yAxis.scale(yAxis.stacked ? (_datum$stackData2 = datum.stackData) == null ? void 0 : _datum$stackData2[1] : yAxis.getValue(datum.originalDatum));
  };

  return /*#__PURE__*/React.createElement("g", {
    style: {
      transform: translate(gridDimensions.gridX, gridDimensions.gridY)
    }
  }, allSeries.map(function (series, i) {
    var _line$curve;

    var style = getSeriesStatusStyle(series, focusedDatum);

    var lineStyle = _extends({}, pathDefaultStyle, style, style.line, {
      fill: 'none'
    });

    var linePath = (_line$curve = line(function (datum) {
      var _getX;

      return (_getX = getX(datum)) != null ? _getX : NaN;
    }, function (datum) {
      var _getY;

      return (_getY = getY(datum)) != null ? _getY : NaN;
    }).curve(curve)(series.datums)) != null ? _line$curve : undefined;
    return /*#__PURE__*/React.createElement("g", {
      key: "lines-" + i
    }, series.datums.map(function (datum, i) {
      var _secondaryAxis$showDa;

      var dataStyle = getDatumStatusStyle(datum, focusedDatum);
      return /*#__PURE__*/React.createElement("circle", {
        key: i,
        ref: function ref(el) {
          datum.element = el;
        },
        r: 2,
        cx: getX(datum),
        cy: getY(datum),
        stroke: "rgba(33,33,33,0.5)",
        fill: "transparent",
        style: _extends({
          // @ts-ignore
          r: 2
        }, style, style.circle, dataStyle, dataStyle.circle, !((_secondaryAxis$showDa = secondaryAxis.showDatumElements) != null ? _secondaryAxis$showDa : true) ? {
          opacity: 0
        } : {})
      });
    }), /*#__PURE__*/React.createElement("path", {
      d: linePath,
      style: lineStyle
    }));
  }));
}