"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

exports.__esModule = true;
exports["default"] = AreaComponent;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _d3Shape = require("d3-shape");

var _react = _interopRequireDefault(require("react"));

var _Utils = require("../utils/Utils");

var _chartContext = _interopRequireDefault(require("../utils/chartContext"));

var _curveMonotone = require("../utils/curveMonotone");

//
function AreaComponent(_ref) {
  var _secondaryAxis$curve;

  var primaryAxis = _ref.primaryAxis,
      secondaryAxis = _ref.secondaryAxis,
      allSeries = _ref.series;

  var _useChartContext = (0, _chartContext["default"])(),
      getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
      getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
      useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
      gridDimensions = _useChartContext.gridDimensions;

  var curve = (_secondaryAxis$curve = secondaryAxis.curve) != null ? _secondaryAxis$curve : _curveMonotone.monotoneX;

  var _useFocusedDatumAtom = useFocusedDatumAtom(),
      focusedDatum = _useFocusedDatumAtom[0];

  var xAxis = primaryAxis.isVertical ? secondaryAxis : primaryAxis;
  var yAxis = !primaryAxis.isVertical ? secondaryAxis : primaryAxis;

  var getX = function getX(datum) {
    var _datum$stackData;

    return xAxis.scale(xAxis.stacked ? (_datum$stackData = datum.stackData) == null ? void 0 : _datum$stackData[1] : xAxis.getValue(datum.originalDatum));
  };

  var getY = function getY(datum, isEnd) {
    var _datum$stackData2;

    return yAxis.scale(yAxis.stacked ? (_datum$stackData2 = datum.stackData) == null ? void 0 : _datum$stackData2[isEnd] : yAxis.getValue(datum.originalDatum));
  };

  return /*#__PURE__*/_react["default"].createElement("g", {
    style: {
      transform: (0, _Utils.translate)(gridDimensions.gridX, gridDimensions.gridY)
    }
  }, allSeries.map(function (series, i) {
    var _area$curve, _line$curve;

    var style = getSeriesStatusStyle(series, focusedDatum);
    var lineStyle = (0, _extends2["default"])({
      strokeWidth: 2
    }, style, style.line, {
      fill: 'none'
    });
    var areaStyle = (0, _extends2["default"])({
      strokeWidth: 2,
      opacity: 0.5
    }, style, style.area);
    var areaPath = (_area$curve = (0, _d3Shape.area)(function (datum) {
      var _getX;

      return (_getX = getX(datum)) != null ? _getX : NaN;
    }, function (datum) {
      var _getY;

      return (_getY = getY(datum, 0)) != null ? _getY : NaN;
    }, function (datum) {
      var _getY2;

      return (_getY2 = getY(datum, 1)) != null ? _getY2 : NaN;
    }).curve(curve)(series.datums)) != null ? _area$curve : undefined;
    var linePath = (_line$curve = (0, _d3Shape.line)(function (datum) {
      var _getX2;

      return (_getX2 = getX(datum)) != null ? _getX2 : NaN;
    }, function (datum) {
      var _getY3;

      return (_getY3 = getY(datum, 1)) != null ? _getY3 : NaN;
    }).curve(curve)(series.datums)) != null ? _line$curve : undefined;
    return /*#__PURE__*/_react["default"].createElement("g", {
      key: "lines-" + i
    }, /*#__PURE__*/_react["default"].createElement("path", {
      d: areaPath,
      style: areaStyle
    }), /*#__PURE__*/_react["default"].createElement("path", {
      d: linePath,
      style: lineStyle
    }), series.datums.map(function (datum, i) {
      var _getY4, _secondaryAxis$showDa;

      var dataStyle = getDatumStatusStyle(datum, focusedDatum);
      return /*#__PURE__*/_react["default"].createElement("circle", {
        key: i,
        ref: function ref(el) {
          datum.element = el;
        },
        r: 2,
        cx: getX(datum),
        cy: (_getY4 = getY(datum, 1)) != null ? _getY4 : NaN,
        stroke: "rgba(33,33,33,0.5)",
        style: (0, _extends2["default"])({
          // @ts-ignore
          r: 2
        }, style, style.circle, dataStyle, dataStyle.circle, !((_secondaryAxis$showDa = secondaryAxis.showDatumElements) != null ? _secondaryAxis$showDa : true) ? {
          opacity: 0
        } : {})
      });
    }));
  }));
}