"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault")["default"];

exports.__esModule = true;
exports["default"] = BarComponent;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireDefault(require("react"));

var _Utils = require("../utils/Utils");

var _chartContext = _interopRequireDefault(require("../utils/chartContext"));

//
function BarComponent(_ref) {
  var primaryAxis = _ref.primaryAxis,
      secondaryAxis = _ref.secondaryAxis,
      allSeries = _ref.series;

  var _useChartContext = (0, _chartContext["default"])(),
      getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
      getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
      useFocusedDatumAtom = _useChartContext.useFocusedDatumAtom,
      gridDimensions = _useChartContext.gridDimensions;

  var _useFocusedDatumAtom = useFocusedDatumAtom(),
      focusedDatum = _useFocusedDatumAtom[0];

  return /*#__PURE__*/_react["default"].createElement("g", {
    style: {
      transform: (0, _Utils.translate)(gridDimensions.gridX, gridDimensions.gridY)
    }
  }, allSeries.map(function (series, i) {
    var style = getSeriesStatusStyle(series, focusedDatum);
    return /*#__PURE__*/_react["default"].createElement("g", {
      key: "lines-" + i
    }, series.datums.map(function (datum, i) {
      var _getX, _getY, _getWidth, _getHeight;

      var dataStyle = getDatumStatusStyle(datum, focusedDatum);
      return /*#__PURE__*/_react["default"].createElement("rect", {
        ref: function ref(el) {
          datum.element = el;
        },
        key: i,
        x: (_getX = (0, _Utils.getX)(datum, primaryAxis, secondaryAxis)) != null ? _getX : NaN,
        y: (_getY = (0, _Utils.getY)(datum, primaryAxis, secondaryAxis)) != null ? _getY : NaN,
        width: (_getWidth = (0, _Utils.getWidth)(datum, primaryAxis, secondaryAxis)) != null ? _getWidth : NaN,
        height: (_getHeight = (0, _Utils.getHeight)(datum, primaryAxis, secondaryAxis)) != null ? _getHeight : NaN,
        style: (0, _extends2["default"])({
          strokeWidth: 0
        }, style, style.rectangle, dataStyle, dataStyle.rectangle)
      });
    }));
  }));
}